{
Volume3D
3D function library for CAM purposes

program author
Arndt Kritzner, see http://www.kritzner.de

version
1.0.3 ... 2003-04-26
1.0.2 ... 2003-02-23
1.0.1 ... 2003-01-18
1.0 ... 2002-09-07

licenses:
volume3d is available under the terms of GNUs GPL (for developers of free software,
only FreePascal or GNU Pascal with Linux) or alternatively under a commercial
license (for developers of commercial software)

All rights reserved.
Any usage in another kind than described in the purchased license is prohibited.
If you want to choose the GNU GPL on another platform than GNU/Linux ask for a
free license for your preferred OS mailto:arndt@kritzner.de.

See http://www.kritzner.de/pages/v3d/v3d.html for technical and licensing details.
}

{
rp.pp
control program for rp (rapid prototyping) process
}

program rp;

uses triangle3d,shape3d,export3d;

const	leftbrace='<';
			rightbrace='> ';
			separator=',';
var objekt:pshape_3d;
      file_name:string;
      end_command:boolean;
      request:string;
      start_point,direction:tpoint;
      inside,ok,skip:boolean;
      val_err:integer;
      idx,rel_idx:tri_idx3d;
      r,rel,rtest:ttrianglerelation;
begin
	if ParamCount=1 then begin
		file_name:=ParamStr(1);
		objekt:=Nil;
		if (Length(file_name)>3) then begin
			if ('.gts'=Copy(file_name,Length(file_name)-3,Length(file_name)))
			then begin
				WriteLn('rp: reading .gts model from ',file_name,'.');
				objekt:=import_gts(file_name);
				if Assigned(objekt) then
					facet_orientation(objekt);
			end else
				if ('.stl'=Copy(file_name,Length(file_name)-3,Length(file_name)))
				then begin
					WriteLn('rp: reading .stl model from ',file_name,'.');
					objekt:=import_stl(file_name,$ffffff);
				end;
		end;
		if Assigned(objekt) then begin
			WriteLn('rp: ready');
			end_command:=false;
			while not end_command do begin
				ReadLn(request);
				if request='exit' then begin
					WriteLn('bye');
					end_command:=true;
				end else begin
					ok:=true;
					if Pos(leftbrace,request)>0 then
						Delete(request,1,Pos(leftbrace,request)+Length(leftbrace)-1)
					else
						ok:=false;
					if ok and (Pos(separator,request)>0) then begin
						val(Copy(request,1,Pos(separator,request)-1),start_point.x,val_err);
						if val_err=0 then
							Delete(request,1,Pos(separator,request)+Length(separator)-1)
						else
							ok:=false;
					end else
						ok:=false;
					if ok and (Pos(separator,request)>0) then begin
						val(Copy(request,1,Pos(separator,request)-1),start_point.y,val_err);
						if val_err=0 then
							Delete(request,1,Pos(separator,request)+Length(separator)-1)
						else
							ok:=false;
					end else
						ok:=false;
					if ok and (Pos(rightbrace,request)>0) then begin
						val(Copy(request,1,Pos(rightbrace,request)-1),start_point.z,val_err);
						if val_err=0 then
							Delete(request,1,Pos(rightbrace,request)+Length(rightbrace)-1)
						else
							ok:=false;
					end else
						ok:=false;
					if Length(request)=4 then begin
						if Copy(request,1,3)='-x ' then
							direction:=point(-1,0,0)
						else if Copy(request,1,3)='+x ' then
							direction:=point(1,0,0)
						else if Copy(request,1,3)='-y ' then
							direction:=point(0,-1,0)
						else if Copy(request,1,3)='+y ' then
							direction:=point(0,1,0)
						else if Copy(request,1,3)='-z ' then
							direction:=point(0,0,-1)
						else if Copy(request,1,3)='+z ' then
							direction:=point(0,0,1)
						else
							ok:=false;
						if Copy(request,4,1)='-' then
							inside:=false
						else if Copy(request,4,1)='+' then
							inside:=true
						else
							ok:=false;
					end else
						ok:=false;
					if ok then begin
						repeat
							skip:=false;
							idx:=0;
							rel.d:=0;
							rel.r:=tt_none;
							while idx<objekt^.count do begin
								r:=beam_triangle(points_2_line(start_point,vec_add(start_point,direction)),objekt^.get_triangle(idx));
{$ifdef LOG}
								case r.r of
									tt_back:WriteLn('von innen (',r.d:0:4,').');
									tt_surf:WriteLn('von aussen (',r.d:0:4,').');
									tt_none:WriteLn('kein Durchstoss.');
									else WriteLn('????');
								end;
{$endif}
								if r.d>0 then
									if ((rel.r=tt_none) or (rel.d>r.d)) and ((inside and (r.r in [tt_back])) or ((not inside) and (r.r in [tt_surf]))) then begin
										rel.r:=r.r;
										rel.d:=r.d;
										rel_idx:=idx;
{$ifdef LOG}
										case rel.r of
											tt_back:WriteLn('aus dem Material heraus (',rel.d:0:4,').');
											tt_surf:WriteLn('ins Material hinein (',rel.d:0:4,').');
										end;
{$endif}
									end;
								inc(idx);
							end;
							if rel.r<>tt_none then begin
								idx:=0;
								rtest.d:=0;
								rtest.r:=tt_none;
								while idx<objekt^.count do begin
									r:=beam_triangle(points_2_line(start_point,vec_add(start_point,direction)),objekt^.get_triangle(idx));
									if (r.d+eps>rel.d) and (rel.d+eps>r.d) then
										if (inside and (r.r in [tt_surf])) or ((not inside) and (r.r in [tt_back])) then begin
											rtest.r:=r.r;
											rtest.d:=r.d;
										end;
									inc(idx);
								end;
							end;
							if rel.r<>tt_none then begin
								start_point:=pane_X_line(tri_2_pane(objekt^.get_triangle(rel_idx)),start_point,vec_add(start_point,direction),true).p;
								if rtest.r=tt_none then begin
									if rel.r in [tt_back] then
										WriteLn('<',start_point.x:0:4,',',start_point.y:0:4,',',start_point.z:0:4,'> -')
									else
										WriteLn('<',start_point.x:0:4,',',start_point.y:0:4,',',start_point.z:0:4,'> +');
								end else begin
									skip:=true;
								end
							end else
								WriteLn('<>');
						until not skip;
					end else
						WriteLn(stderr,'a what?');
				end;
			end;
			dispose(objekt,done);
		end else
			WriteLn('rp: got no model from ',file_name,'.');;
	end else
		WriteLn('Usage: rp <filename>');
end.

